blob: 189a673ac33e23146c1bac74d9d688a07a1fbb49 [file] [log] [blame]
Andy Bavier37044342015-02-06 16:39:06 -05001#!/bin/bash
Siobhan Tully44fd4cc2014-02-23 00:07:12 -05002
3if [ -z "$1" ]; then
Scott Bakerf4db3812014-05-09 16:42:13 -07004 echo usage: $0 "[initdb | createdb | dropdb | syncdb | runserver | resetdb | dumpdata]"
Siobhan Tully44fd4cc2014-02-23 00:07:12 -05005 exit
6fi
7
Scott Baker0c550f72015-02-04 21:50:08 -08008XOS_DIR=/opt/xos
9BACKUP_DIR=/opt/xos_backups
Scott Baker82d62282015-02-19 21:56:58 -080010DBNAME=xos
Scott Bakerb4785022014-05-15 13:22:28 -070011
Scott Bakera40c9352014-09-16 09:46:35 -070012DJANGO_17=`python -c "import django; from distutils.version import StrictVersion; print int(StrictVersion(django.get_version()) >= StrictVersion('1.7'))"`
13
Scott Bakerd232c2b2015-02-04 15:04:26 -080014cd $XOS_DIR
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050015
Scott Baker4b71a2d2015-02-19 11:34:41 -080016function is_ubuntu {
17 if ! which lsb_release &> /dev/null; then
18 # lsb_release is not installed
19 return 1
20 fi
21 if lsb_release -i | grep -i ubuntu &> /dev/null; then
22 return 0
23 fi
24 return 2
25}
26
Scott Bakerb4785022014-05-15 13:22:28 -070027function ensure_postgres_running {
28 # "sudo -u postgres pg_ctl -D /var/lib/postgres/data status" doesn't work
29 # right on Vicci, so let's try to detect it by seeing if the port is
30 # being listened on
31
Scott Baker4b71a2d2015-02-19 11:34:41 -080032 netstat -nl | grep -i ":5432 " > /dev/null
Scott Bakerb4785022014-05-15 13:22:28 -070033 if [[ $? == 0 ]]; then
34 echo "Postgres is already running"
35 return
36 fi
37
Scott Baker4b71a2d2015-02-19 11:34:41 -080038 # note that initdb isn't needed in Ubuntu distributions, and calling it
39 # will throw spurious error messages
40 if ! is_ubuntu; then
41 service postgresql initdb
42 fi
Andy Bavier37044342015-02-06 16:39:06 -050043 service postgresql start
Scott Bakerb4785022014-05-15 13:22:28 -070044
Scott Baker4b71a2d2015-02-19 11:34:41 -080045 netstat -nl | grep -i ":5432 " > /dev/null
Scott Bakerb4785022014-05-15 13:22:28 -070046 if [[ $? != 0 ]]; then
Scott Baker4b71a2d2015-02-19 11:34:41 -080047 # it's still not running...
48 # this is intended for Vicci where some D-Bus issue is
49 # preventing systemctl from working properly.
Scott Bakerb4785022014-05-15 13:22:28 -070050 echo "Trying fallback mechanism to start Postgres"
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050051 sudo -u postgres initdb -D /var/lib/pgsql/data/
52 sudo -u postgres pg_ctl -D /var/lib/pgsql/data -l logfile start
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050053 fi
Scott Bakerb4785022014-05-15 13:22:28 -070054
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050055}
Scott Baker4b71a2d2015-02-19 11:34:41 -080056
Scott Bakercecee002015-07-20 10:57:08 -070057function wait_postgres {
58 sudo -u postgres psql -c '\q'
59 while [[ "$?" != "0" ]]; do
60 echo Waiting for postgres to start
61 sleep 1
62 sudo -u postgres psql -c '\q'
63 done
64}
65
Scott Baker4b71a2d2015-02-19 11:34:41 -080066function db_exists {
67 sudo -u postgres psql $DBNAME -c '\q' 2>/dev/null
68 return $?
69}
70
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050071function createdb {
Scott Bakercecee002015-07-20 10:57:08 -070072 wait_postgres
Scott Bakerd232c2b2015-02-04 15:04:26 -080073 echo "Creating XOS database..."
74 sudo -u postgres createdb $DBNAME
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050075}
76function dropdb {
Scott Bakerd232c2b2015-02-04 15:04:26 -080077 echo "Dropping XOS database..."
78 sudo -u postgres dropdb $DBNAME
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050079}
80function syncdb {
Scott Bakerd232c2b2015-02-04 15:04:26 -080081 echo "Syncing XOS services..."
Scott Baker596397c2015-02-04 22:47:45 -080082 python $XOS_DIR/manage.py syncdb --noinput
Scott Bakera40c9352014-09-16 09:46:35 -070083 if [[ $DJANGO_17 ]]; then
84 echo "Loading initial data from fixture..."
Scott Baker596397c2015-02-04 22:47:45 -080085 python $XOS_DIR/manage.py --noobserver --nomodelpolicy loaddata $XOS_DIR/core/fixtures/initial_data.json
Scott Bakera40c9352014-09-16 09:46:35 -070086 fi
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050087}
Scott Baker25b70fd2014-05-15 14:11:58 -070088function evolvedb {
Scott Bakerd232c2b2015-02-04 15:04:26 -080089 echo "Evolving XOS services..."
Scott Baker596397c2015-02-04 22:47:45 -080090 python $XOS_DIR/manage.py evolve --hint --execute --noinput
Scott Baker25b70fd2014-05-15 14:11:58 -070091}
Scott Bakere363ac02014-09-12 15:10:01 -070092function migratedb {
Scott Bakerd232c2b2015-02-04 15:04:26 -080093 echo "Migrating XOS services..."
Scott Baker596397c2015-02-04 22:47:45 -080094 python $XOS_DIR/manage.py migrate
Scott Bakere363ac02014-09-12 15:10:01 -070095}
Scott Bakerb4785022014-05-15 13:22:28 -070096function stopserver {
Scott Bakerd232c2b2015-02-04 15:04:26 -080097 echo "Stopping any running XOS Service(s)"
Scott Bakerb4785022014-05-15 13:22:28 -070098 pkill -f "python.*runserver"
99}
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500100function runserver {
Andy Bavier37044342015-02-06 16:39:06 -0500101 ensure_postgres_running
Scott Baker596397c2015-02-04 22:47:45 -0800102 PUBLIC_HOSTNAME=`$XOS_DIR/xos-config.py get server_hostname $HOSTNAME`
Scott Bakerd232c2b2015-02-04 15:04:26 -0800103 echo "Starting XOS Service on $PUBLIC_HOSTNAME:8000"
Scott Baker3a96c542015-02-06 16:26:04 -0800104 python manage.py runserver $PUBLIC_HOSTNAME:8000 --insecure&
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500105}
106
Scott Bakerf4db3812014-05-09 16:42:13 -0700107function dumpdata {
Scott Bakerb4785022014-05-15 13:22:28 -0700108 mkdir -p $BACKUP_DIR
109 FN="$BACKUP_DIR/dumpdata-`date +%Y-%m-%d_%H:%M:%S`.json"
110 echo "Saving data to $FN"
Scott Bakera2e881c2014-08-15 16:52:55 -0700111 python manage.py dumpdata core hpc syndicate_storage requestrouter -a --indent 4 > $FN
Scott Bakerb4785022014-05-15 13:22:28 -0700112 if [[ ! -f $FN ]]; then
113 echo "FAILED to create $FN"
114 exit
115 fi
Scott Baker25b70fd2014-05-15 14:11:58 -0700116 SIZE=$(du -k "$FN" | cut -f 1)
117 if [[ $SIZE -lt 9 ]]; then
118 echo "Dumpdata was empty. Deleting and aborting"
119 rm $FN
120 exit
121 fi
Scott Bakerb4785022014-05-15 13:22:28 -0700122 rm -f $BACKUP_DIR/dumpdata-latest.json
123 ln -s $FN $BACKUP_DIR/dumpdata-latest.json
Scott Bakerf4db3812014-05-09 16:42:13 -0700124}
125
Sapan Bhatia51a92b12014-09-08 10:53:53 -0400126function genkeys {
127 mkdir -p public_keys
128 mkdir -p private_keys
129 echo "Generating keys"
130 keyczart create --location=private_keys --name="OpenCloud" --purpose=crypt --asymmetric=rsa
131 keyczart addkey --location=private_keys --status=primary --size=1024
132 keyczart pubkey --location=private_keys --destination=public_keys
133 if [[ ! -f public_keys/1 ]]; then
134 echo "FAILED to create keys"
135 exit
136 fi
137}
138
Tony Mackf4f57932015-10-31 14:18:11 +0000139function makemigrations {
Tony Mackdb841862015-11-01 13:50:12 +0000140 rm -rf /opt/xos/*/migrations /opt/xos/services/*/migrations
Scott Bakerba4e0102015-02-18 16:42:14 -0800141 python ./manage.py makemigrations core
142 python ./manage.py makemigrations hpc
143 python ./manage.py makemigrations requestrouter
144 python ./manage.py makemigrations syndicate_storage
Scott Bakerfd15c3d2015-05-06 12:04:09 -0700145 python ./manage.py makemigrations cord
Scott Baker48cf8742015-09-10 09:02:01 -0700146 python ./manage.py makemigrations ceilometer
Scott Bakerc44448c2015-10-16 16:54:07 -0700147 python ./manage.py makemigrations onos
Scott Bakerba4e0102015-02-18 16:42:14 -0800148 #python ./manage.py makemigrations servcomp
149}
150
Tony Mackf4f57932015-10-31 14:18:11 +0000151function remigrate {
152 if db_exists; then
153 dropdb
154 fi
155 makemigrations
156}
157
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500158COMMAND=$1
159
160if [ "$COMMAND" = "initdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700161 stopserver
162 ensure_postgres_running
163 createdb
164 syncdb
Scott Bakerb4785022014-05-15 13:22:28 -0700165fi
Scott Baker25b70fd2014-05-15 14:11:58 -0700166if [ "$COMMAND" = "repairdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700167 stopserver
168 ensure_postgres_running
169 dumpdata
Scott Baker25b70fd2014-05-15 14:11:58 -0700170 # TODO: This is where we could run migration scripts to upgrade the
Scott Bakerb4785022014-05-15 13:22:28 -0700171 # dumped data to the new models.
Scott Baker596397c2015-02-04 22:47:45 -0800172 mv $XOS_DIR/core/fixtures/initial_data.json $XOS_DIR/core/fixtures/initial_data.json-old
173 cp $BACKUP_DIR/dumpdata-latest.json $XOS_DIR/core/fixtures/initial_data.json
Scott Bakerb4785022014-05-15 13:22:28 -0700174 dropdb
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500175 createdb
176 syncdb
Scott Baker25b70fd2014-05-15 14:11:58 -0700177fi
178if [ "$COMMAND" = "restoredb" ]; then
179 if [[ ! -f $BACKUP_DIR/dumpdata-latest.json ]]; then
180 echo There is no dumpdata to restore
181 exit
182 fi
183 stopserver
184 ensure_postgres_running
Scott Baker596397c2015-02-04 22:47:45 -0800185 mv $XOS_DIR/core/fixtures/initial_data.json $XOS_DIR/core/fixtures/initial_data.json-old
186 cp $BACKUP_DIR/dumpdata-latest.json $XOS_DIR/core/fixtures/initial_data.json
Scott Baker25b70fd2014-05-15 14:11:58 -0700187 dropdb
188 createdb
189 syncdb
190fi
Scott Bakerbaf62562014-09-17 22:19:54 -0700191if [ "$COMMAND" = "evolvedb" -o "$COMMAND" = "migratedb" ]; then
Scott Baker25b70fd2014-05-15 14:11:58 -0700192 stopserver
193 ensure_postgres_running
Scott Bakerbaf62562014-09-17 22:19:54 -0700194 if [[ $DJANGO_17 ]]; then
195 migratedb
196 else
197 evolvedb
198 fi
Scott Bakere363ac02014-09-12 15:10:01 -0700199fi
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500200if [ "$COMMAND" = "resetdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700201 stopserver
S.Çağlar Onur3c297b42015-02-24 15:34:39 -0500202 ensure_postgres_running
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500203 dropdb
204 createdb
205 syncdb
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500206fi
207if [ "$COMMAND" = "syncdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700208 stopserver
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500209 syncdb
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500210fi
211if [ "$COMMAND" = "runserver" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700212 stopserver
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500213 runserver
214fi
Scott Bakerb4785022014-05-15 13:22:28 -0700215if [ "$COMMAND" = "stopserver" ]; then
216 stopserver
217fi
Scott Bakerf4db3812014-05-09 16:42:13 -0700218if [ "$COMMAND" = "dumpdata" ]; then
219 dumpdata
220fi
Sapan Bhatia51a92b12014-09-08 10:53:53 -0400221if [ "$COMMAND" = "genkeys" ]; then
222 genkeys
223fi
Scott Baker069ca8b2015-02-16 23:34:48 -0800224if [ "$COMMAND" = "generateapi" ]; then
Scott Bakerd82a9dd2015-02-16 23:47:11 -0800225 python apigen/modelgen apigen/api.template.py > xos/xosapi.py
Scott Bakerba4e0102015-02-18 16:42:14 -0800226fi
227if [ "$COMMAND" = "remigrate" ]; then
228 ensure_postgres_running
229 remigrate
230 createdb
231 syncdb
S.Çağlar Onur3c297b42015-02-24 15:34:39 -0500232fi
Tony Mackf4f57932015-10-31 14:18:11 +0000233if [ "$COMMAND" = "makemigrations" ]; then
234 makemigrations
235 syncdb
236fi